<template>
  <div>
    <!-- Form Generator -->
    <b-row v-if="isLoadingFormGenerator" align-h="center" class="my-2">
      <b-spinner variant="primary" />
    </b-row>
    <div v-else-if="resource">
      <div class="h6 text-center mb-3">
        {{ $t("default.applicationProfile") }}:
        <a :href="resource?.applicationProfile?.uri" target="_blank">{{
          applicationProfile?.displayName ?? resource?.applicationProfile?.uri
        }}</a>
      </div>
      <FormGenerator
        :key="resource.applicationProfile?.uri + '' + templateApplied"
        :disabled-mode="!isUserAllowedToEdit || resource.archived"
        :fixed-value-mode="true"
        :fixed-values="fixedValues"
        :ignore-template-values="resource.metadataExtraction === true"
        :locale="$i18n.locale"
        :selected-shape="resource.applicationProfile?.uri"
        :shapes="applicationProfile?.definition"
        :class-receiver="getVocabularyInstances"
        :instance-receiver="getVocabularyInstance"
        :user-receiver="async () => user"
        shape-mime-type="application/ld+json"
        @update:fixed-values="inputFixedValues"
      />
    </div>
    <div v-if="resource?.metadataExtraction === true">
      <b-button
        class="float-start"
        variant="secondary"
        @click.prevent="openTemplateModal"
      >
        {{ $t("page.settings.applicationProfile.openTemplateModal") }}
      </b-button>
    </div>
    <TemplateModals
      :open="areTemplateModalsVisible"
      :application-profile="applicationProfile"
      :resource-form="resourceForm"
      @close="areTemplateModalsVisible = false"
      @update:modelValue="inputFixedValuesTemplate"
    />
  </div>
</template>

<script lang="ts" setup>
// import the store for current module
import useResourceStore from "../../store";
import useUserStore from "@/modules/user/store";
import TemplateModals from "./modals/template/TemplateModals.vue";
import type { ResourceForUpdateDto } from "@coscine/api-client/dist/types/Coscine.Api";
import type {
  ApplicationProfileDefinition,
  BilingualLabel,
  BilingualLabels,
  FixedValuesForResource,
} from "../../types";
import type { FixedValues } from "@coscine/form-generator/dist/types/fixedValues";

const resourceForm = defineModel<ResourceForUpdateDto>({ required: true });

defineProps({
  applicationProfile: {
    type: [Object, null] as PropType<ApplicationProfileDefinition | null>,
    default: null,
  },
  isLoadingFormGenerator: {
    type: Boolean,
    required: true,
  },
  isUserAllowedToEdit: {
    default: false,
    type: Boolean,
  },
});

const resourceStore = useResourceStore();
const userStore = useUserStore();

const areTemplateModalsVisible = ref(false);
const templateApplied = ref(0);

const resource = computed(() => {
  return resourceStore.currentResource;
});
const user = computed(() => {
  return userStore.user ?? { displayName: undefined };
});
const fixedValues = computed(() => {
  return resourceForm.value.fixedValues as FixedValues;
});

const inputFixedValues = (fixedValues: FixedValuesForResource) => {
  resourceForm.value.fixedValues = fixedValues;
};

const inputFixedValuesTemplate = (fixedValues: FixedValuesForResource) => {
  templateApplied.value++;
  inputFixedValues(fixedValues);
};

/**
 * Fetches vocabulary instance from the store.
 */
const getVocabularyInstance = async (
  instanceUrl: string,
): Promise<BilingualLabel> => {
  return await resourceStore.getVocabularyInstance(instanceUrl);
};

/**
 * Fetches vocabulary instances for a given class name from the store.
 *
 * @async
 * @param {string} className - The class name for which vocabulary instances need to be fetched.
 * @param {number} pageNumber - The pageNumber for retrieving the correct page of files.
 * @param {number} pageSize - The pageSize for retrieving the correct size of the files.
 * @returns {Promise<BilingualLabels>} Returns a promise resolving to bilingual labels.
 */
const getVocabularyInstances = async (
  className: string,
  pageNumber: number,
  pageSize: number,
  searchTerm?: string | undefined,
): Promise<BilingualLabels> => {
  return await resourceStore.getVocabularyInstances(
    className,
    pageNumber,
    pageSize,
    searchTerm,
  );
};
const openTemplateModal = () => {
  areTemplateModalsVisible.value = true;
};
</script>
